class NodeDL:
    def __init__(self,value):
        self.data = value 
        self.next = None
        self.prev = None

class LLDL:
    def __init__(self):
        # this is the head of the double linked list . This has initially no Prev and no Next.
        self.h = None
        
    def createDL(self,value):
        nn = NodeDL(value)
        if self.h is None:
            self.h = nn
        else:
            t = self.h
            #t2 = self.h
            while(t.next is not None ) :
                t = t.next
                #t2 = t1.prev
            t.next = nn
            nn.prev = t
    
    def showDL(self):
        t= self.h
        i = 0
        while (t is not None):
            print(f"{i}:next {t.data}",end=",")
            i+=1
            t = t.next
        print(f"{i}:next {None}")
        
    def insertDL(self,value,position):
        # TODO1 : create a new node for the given value
        nn = NodeDL(value)
        # TODO2 : evaluate the edge cases like self.h is None and case when position is greater than size of the linked list
        if self.h is None:
            self.h = nn
            nn.next = None
            nn.prev = None
            return self.showDL()
        # TODO3 : Reach the position
        t = self.h
        c = 0 
        # 
        while c<position and t.next is not None:
            c+=1
            t = t.next

        # TODO4 : Attach the new node with the position . remember to update the next for the new node.
        nn.next = t.next
        #nn.prev = t
        #t.next.prev = nn
        # TODO5 : delink the current node with the position and connect it to the new node.
        t.next = nn
        nn.prev = t
        # TODO6 : update the previous node of the position node with the new node 
        if nn.next is not None:
            nn.next.prev = nn
        # TODO7 : update the previous node of the new node to the current node ( current node is the old node connected with the position ) 
        #nn.prev = t
        return self.showDL()
        
        
    
    def deleteDL(self,position):
        pass
    
        
my_dl = LLDL()
my_dl.createDL(10)
my_dl.createDL(20)
my_dl.createDL(30)
my_dl.showDL()
my_dl.insertDL(27,0)