import random

class NodeRLL:
    def __init__(self,value):
        self.data = value
        self.next = None
        self.random = None
        
class RandomLL:
    def __init__(self):
        self.h = None
    
    def createRLL(self,value):
        nn = NodeRLL(value)
        if self.h is None:
            self.h = nn
        else:
            t = self.h
            while t.next is not None:
                t = t.next
            t.next = nn
            
    def sizeRLL(self):
        t = self.h
        c = 0
        while t is not None:
            c+=1
            t=t.next
        return c
    
    def set_randomRLL(self):
        size = self.sizeRLL()
        t = self.h
        if size == 0 :
            return None
        node_list = [None]
        while t is not None:
            node_list.append(t)
            t=t.next
        print(node_list)
        t = self.h
        while t is not None:
            t.random = random.choice(node_list)
            t = t.next
        t = self.h
        i = 0
        while t is not None:
            if t.random is not None:
                print(f"{i}:{t.data}:{t.random.data}",end=",")
            else:
                print(f"{i}:{t.data}:{t.random}",end=",")
            i+=1
            t = t.next
        print(f"{i}:{None}:{None}")
    
    def displayRLL(self):
        t = self.h
        i = 0
        while t is not None :
            print(f"{i}:{t.data}",end=",")
            i+=1
            t = t.next
        print(f"{i}:{None}")
    
    def displayWithHeadRLL(self,head):
        t = head
        i = 0 
        while t is not None:
            print(f"{i}:{t.data}",end=",")
            i+=1
            t = t.next
        print(f"{i}:{None}")
    
    def insertRLL(self,value,position,flag=0):
        # TODO1 : Creating a new node with the given value
        nn = NodeRLL(value)
        # TODO2 : Connecting the node with the given position
        ## reach the given position 
        ### Edge cases 
        if self.h is None:# if there is no node at all then whatever the position given it will go to the first node only
            self.h = nn
            return self.h
        t = self.h
        c = 0
        # 8   > 9   > pos > 10 > 2 > 4 > None
        # t,0 > t,1 > 
        while c<position and t.next is not None:
            c+=1
            t = t.next
        nn.next = t.next # now here nn.next ( new node attached )  = 10 = t.next (current) .if t.next is None then nn.next will also become None
        # TODO3 : Delinking the previous node with the given position and linking it with the new node without disturbing the random node
        t.next = nn
        # TODO4 : Since no instruction given for random node . Assign the random node to None if flag = 0 and to itself if flag = 1
        if flag:
            nn.random = nn
        else:
            nn.random = None
        
        return self.displayRLL()
    
    def deleteRLL(self,value):
        pass

    def deep_copyRLL(self,head):
        # TODO1 : Insertion of duplicate in between every node
        # TODO2 : Setting up random nodes as per the original 
        # TODO3 : Delinking the original from the duplicate
        pass
    

my_RL = RandomLL()
my_RL.displayRLL()
my_RL.createRLL(8)
my_RL.createRLL(9)
my_RL.createRLL(1)
my_RL.createRLL(14)
my_RL.createRLL(21)
my_RL.createRLL(35)
my_RL.displayRLL()
my_RL.set_randomRLL()
my_RL.insertRLL(19,3)