from setuptools import setup, find_packages

setup(
    name='dsa-for-all',
    version='1.0.1.2',
    description='DSA For All package for learning Data Structures and Algorithms',
    long_description=open('README.md').read(),
    long_description_content_type='text/markdown',
    author='Your Name',
    author_email='your.email@example.com',
    url='https://github.com/yourusername/dsa-for-all',
    packages=find_packages(exclude=['tests']),
    install_requires=[
        # Add any dependencies required by your package
    ],
    classifiers=[
        'Development Status :: 5 - Production/Stable',
        'Intended Audience :: Developers',
        'License :: OSI Approved :: MIT License',
        'Programming Language :: Python :: 3',
        'Programming Language :: Python :: 3.6',
        'Programming Language :: Python :: 3.7',
        'Programming Language :: Python :: 3.8',
        'Programming Language :: Python :: 3.9',
        'Programming Language :: Python :: 3.10',
        'Programming Language :: Python :: 3.11',
        'Operating System :: OS Independent',
    ],
    keywords='data-structures algorithms dsa',
    project_urls={
        'Documentation': 'https://yourprojectdocs.com',
        'Source': 'https://github.com/yourusername/dsa-for-all',
        'Bug Reports': 'https://github.com/yourusername/dsa-for-all/issues',
    },
    python_requires='>=3.6',
    license='MIT',
)
